;PCM by KZ-S
; INES header setup
	.inesprg	64	; 16k prg bank
	.ineschr	0	; 8k  chr bank
	.inesmir	0	; Horizontal map mirroring
	.inesmap	2	; Use mapper

ADDR	= $00
BANKNO	= $02

	.bank 0
	.incbin "pcm_dat.bin"	;7bitWAVEfile	Maxsize = 1,032,190 Byte
	db $C0,$C0

	.bank 126
	.org $C000

	.bank 127
	.org $E000

Reset
	cld			;Clear decimal flag
	sei			;Disable interrupts
.WaitV:	
	lda $2002
	bpl .WaitV		;Wait for vertical blanking interval
	ldx #$00
	stx $2000
	stx $2001		;Screen display off, amongst other things
	dex
	txs			;Top of stack at $1FF

	ldy #$07
	sty <$01   		;Store count value in $01
	ldy #$00
	sty <$00
	lda #$00
.Clear:
	sta [$00],y 		;Clear $100 bytes
	dey
	bne .Clear

	dec <$01		;Decrement "banks" left counter
	bpl .Clear		;Do next if >= 0
	
	sta <$01
	;mem clear end

;@
	ldy #$00
	sty $2000	;NMI off
	sty $2001
	sty $4010
	sty $4011
	sty $4012
	sty $4013
	sty $8000

	sty <ADDR	;Addr low
	ldx #$80
	stx <ADDR+1	;Addr high
	sty <BANKNO	;bank No.

	
.loop
	lda [ADDR],y	;5
	sta $4011	;4
	inc <ADDR	;5
;	#16

	bne .notinc	;2/3	no addr inc
;	#18

	lda <ADDR+1	;3
	cmp #$BF	;2
	bne .notchg	;2/3	no bank change
;	#25

	stx <ADDR+1	;3	store #$80
	inc <BANKNO	;5	bank No.
	lda <BANKNO	;3
	sta $8000	;4	bank change
;	#38

	lda [ADDR],y	;5
	bmi Reset	;2
	sta $4011	;4
	inc <ADDR	;5
;	#16

	bne .notinc	;2/3	no addr inc
;	#18

	lda <ADDR+1	;3
	cmp #$BF	;2
	bne .notchg	;2/3	no bank change
;	#25

	stx <ADDR+1	;3	store #$80
	inc <BANKNO	;5	bank No.
	lda <BANKNO	;3
	sta $8000	;4	bank change
;	#40

.wait
;	1789772.5 / (Hz) = wait clocks
;	ex. 1789772.5 / 44100 = 40.6 --> 41 clocks

;	#40 + #1   = #41 for 44,100Hz
	jmp .loop	;3	2 clocks over

;	#38 + #43 / 2 = #40.5
	
	
.notinc
;	#19
	pha		;3
	pla		;4
	clc		;2
	bcc .notchg2	;3
	
.notchg
;	#26
	inc <ADDR+1	;5
.notchg2
;	#31
	nop		;2
	nop		;2
	clc		;2
	bcc .wait	;3
;	#40

NMI
IRQ
	rti

    .org  $FFFA
	.dw		NMI
	.dw		Reset
	.dw		IRQ

